Index: issm/trunk/src/c/objects/Pengrid.cpp
===================================================================
--- issm/trunk/src/c/objects/Pengrid.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Pengrid.cpp	(revision 465)
@@ -135,5 +135,5 @@
 	return my_rank; 
 }
-void  Pengrid::DistributeNumDofs(int* numdofpernode,int analysis_type){return;}
+void  Pengrid::DistributeNumDofs(int* numdofpernode,int analysis_type,int sub_analysis_type){return;}
 
 #undef __FUNCT__ 
@@ -156,5 +156,5 @@
 #define __FUNCT__ "Pengrid::CreateKMatrix"
 
-void  Pengrid::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Pengrid::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*No loads applied, do nothing: */
@@ -165,5 +165,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Pengrid::CreatePVector"
-void  Pengrid::CreatePVector(Vec pg, void* inputs, int analysis_type){
+void  Pengrid::CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type){
 
 	/*No loads applied, do nothing: */
@@ -179,13 +179,13 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Pengrid::PenaltyCreateKMatrix"
-void  Pengrid::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type){
-
-	if ((analysis_type==DiagnosticStokesAnalysisEnum())){
-
-		PenaltyCreateKMatrixDiagnosticStokes( Kgg,inputs,kmax,analysis_type);
+void  Pengrid::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
+
+	if ((analysis_type==DiagnosticAnalysisEnum()) && ((sub_analysis_type==StokesAnalysisEnum()))){
+
+		PenaltyCreateKMatrixDiagnosticStokes( Kgg,inputs,kmax,analysis_type,sub_analysis_type);
 
 	}
 	else{
-		throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","analysis: ",analysis_type," not supported yet"));
+		throw ErrorException(__FUNCT__,exprintf("%s%i%s%i%s","analysis: ",analysis_type," and sub_analysis_type: ",sub_analysis_type," not supported yet"));
 	}
 
@@ -194,5 +194,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Pengrid::PenaltyCreateKMatrixDiagnosticStokes"
-void  Pengrid::PenaltyCreateKMatrixDiagnosticStokes(Mat Kgg,void* vinputs,double kmax,int analysis_type){
+void  Pengrid::PenaltyCreateKMatrixDiagnosticStokes(Mat Kgg,void* vinputs,double kmax,int analysis_type,int sub_analysis_type){
 	
 	const int numgrids=1;
Index: issm/trunk/src/c/objects/Pengrid.h
===================================================================
--- issm/trunk/src/c/objects/Pengrid.h	(revision 464)
+++ issm/trunk/src/c/objects/Pengrid.h	(revision 465)
@@ -39,12 +39,12 @@
 		int   GetId(); 
 		int   MyRank();
-		void  DistributeNumDofs(int* numdofspernode,int analysis_type);
+		void  DistributeNumDofs(int* numdofspernode,int analysis_type,int sub_analysis_type);
 		void  Configure(void* elements,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
-		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type);
-		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type);
-		void  PenaltyCreateKMatrixDiagnosticStokes(Mat Kgg,void* inputs,double kmax,int analysis_type);
+		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
+		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
+		void  PenaltyCreateKMatrixDiagnosticStokes(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
 		void  GetDofList(int* doflist,int* pnumberofdofspernode);
 		Object* copy();
Index: issm/trunk/src/c/objects/Penpair.cpp
===================================================================
--- issm/trunk/src/c/objects/Penpair.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Penpair.cpp	(revision 465)
@@ -182,5 +182,5 @@
 	return my_rank; 
 }
-void  Penpair::DistributeNumDofs(int* numdofspernode,int analysis_type){return;}
+void  Penpair::DistributeNumDofs(int* numdofspernode,int analysis_type,int sub_analysis_type){return;}
 
 #undef __FUNCT__ 
@@ -208,5 +208,5 @@
 #define __FUNCT__ "Penpair::CreateKMatrix"
 
-void  Penpair::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Penpair::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*No loads applied, do nothing: */
@@ -217,5 +217,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penpair::CreatePVector"
-void  Penpair::CreatePVector(Vec pg, void* inputs, int analysis_type){
+void  Penpair::CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type){
 
 	/*No loads applied, do nothing: */
@@ -231,5 +231,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penpair::PenaltyCreateKMatrix"
-void  Penpair::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type){
+void  Penpair::PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
 	if(numdofs==1){
 		
@@ -245,5 +245,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penpair::PenaltyCreatePVector"
-void  Penpair::PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type){
+void  Penpair::PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type){
 	if(numdofs==1){
 		
Index: issm/trunk/src/c/objects/Penpair.h
===================================================================
--- issm/trunk/src/c/objects/Penpair.h	(revision 464)
+++ issm/trunk/src/c/objects/Penpair.h	(revision 465)
@@ -51,11 +51,11 @@
 		int   GetId(); 
 		int   MyRank();
-		void  DistributeNumDofs(int* numdofspernode,int analysis_type);
+		void  DistributeNumDofs(int* numdofspernode,int analysis_type,int sub_analysis_type);
 		void  Configure(void* elements,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
-		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type);
-		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type);
+		void  PenaltyCreateKMatrix(Mat Kgg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
+		void  PenaltyCreatePVector(Vec pg,void* inputs,double kmax,int analysis_type,int sub_analysis_type);
 		Object* copy();
 };
Index: issm/trunk/src/c/objects/Penta.cpp
===================================================================
--- issm/trunk/src/c/objects/Penta.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Penta.cpp	(revision 465)
@@ -284,30 +284,32 @@
 #define __FUNCT__ "Penta::CreateKMatrix"
 
-void  Penta::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Penta::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if ((analysis_type==DiagnosticHorizAnalysisEnum()) || (analysis_type==ControlAnalysisEnum())){
-
-		CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type);
-
-	}
-	else if ((analysis_type==DiagnosticVertAnalysisEnum())){
-
-		CreateKMatrixDiagnosticVert( Kgg,inputs,analysis_type);
-
-	}
-	else if ((analysis_type==DiagnosticStokesAnalysisEnum())){
-
-		CreateKMatrixDiagnosticStokes( Kgg,inputs,analysis_type);
-
-	}
-	else if (
-			(analysis_type==SurfaceSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==SurfaceSlopeComputeYAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeYAnalysisEnum()) 
-			){
-		
-		CreateKMatrixSlopeCompute( Kgg,inputs,analysis_type);
+	if (analysis_type==ControlAnalysisEnum()){
+
+		CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type,sub_analysis_type);
+
+	}
+	else if (analysis_type==DiagnosticAnalysisEnum()){
+	
+		if (sub_analysis_type==HorizAnalysisEnum()){
+		
+			CreateKMatrixDiagnosticHoriz( Kgg,inputs,analysis_type,sub_analysis_type);
+		}
+		else if (sub_analysis_type==VertAnalysisEnum()){
+		
+			CreateKMatrixDiagnosticVert( Kgg,inputs,analysis_type,sub_analysis_type);
+		}
+		else if (sub_analysis_type==StokesAnalysisEnum()){
+		
+			CreateKMatrixDiagnosticStokes( Kgg,inputs,analysis_type,sub_analysis_type);
+		
+		}
+		else throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet"));
+	}
+	else if (analysis_type==SlopeComputeAnalysisEnum()){
+		
+		CreateKMatrixSlopeCompute( Kgg,inputs,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -320,5 +322,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta:CreateKMatrixDiagnosticHoriz"
-void Penta::CreateKMatrixDiagnosticHoriz( Mat Kgg, void* vinputs, int analysis_type){
+void Penta::CreateKMatrixDiagnosticHoriz( Mat Kgg, void* vinputs, int analysis_type,int sub_analysis_type){
 
 
@@ -421,5 +423,5 @@
 		 *and use its CreateKMatrix functionality to fill the global stiffness matrix: */
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-		tria->CreateKMatrix(Kgg,inputs, analysis_type);
+		tria->CreateKMatrix(Kgg,inputs, analysis_type,sub_analysis_type);
 		delete tria;
 		return;
@@ -552,5 +554,5 @@
 
 			tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-			tria->CreateKMatrixDiagnosticHorizFriction(Kgg,inputs,analysis_type);
+			tria->CreateKMatrixDiagnosticHorizFriction(Kgg,inputs,analysis_type,sub_analysis_type);
 			delete tria;
 		}
@@ -573,5 +575,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta:CreateKMatrixDiagnosticVert"
-void Penta::CreateKMatrixDiagnosticVert( Mat Kgg, void* vinputs, int analysis_type){
+void Penta::CreateKMatrixDiagnosticVert( Mat Kgg, void* vinputs, int analysis_type,int sub_analysis_type){
 
 	/* local declarations */
@@ -623,5 +625,5 @@
 	if(onsurface){
 		tria=(Tria*)SpawnTria(3,4,5); //nodes 3,4 and 5 are on the surface
-		tria->CreateKMatrixDiagnosticSurfaceVert(Kgg,inputs, analysis_type);
+		tria->CreateKMatrixDiagnosticSurfaceVert(Kgg,inputs, analysis_type,sub_analysis_type);
 		delete tria;
 	}
@@ -710,5 +712,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta:CreateKMatrixDiagnosticStokes"
-void Penta::CreateKMatrixDiagnosticStokes( Mat Kgg, void* vinputs, int analysis_type){
+void Penta::CreateKMatrixDiagnosticStokes( Mat Kgg, void* vinputs, int analysis_type,int sub_analysis_type){
 
 	int i,j;
@@ -985,27 +987,30 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::CreatePVector"
-void  Penta::CreatePVector(Vec pg, void* inputs, int analysis_type){
+void  Penta::CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type){
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if ((analysis_type==DiagnosticHorizAnalysisEnum()) || (analysis_type==ControlAnalysisEnum())){
-
-		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type);
-	}
-	else if ((analysis_type==DiagnosticVertAnalysisEnum())){
-
-		CreatePVectorDiagnosticVert( pg,inputs,analysis_type);
-	}
-	else if ((analysis_type==DiagnosticStokesAnalysisEnum())){
-
-		CreatePVectorDiagnosticStokes( pg,inputs,analysis_type);
-	}
-	else if (
-			(analysis_type==SurfaceSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==SurfaceSlopeComputeYAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeXAnalysisEnum()) || 
-			(analysis_type==BedSlopeComputeYAnalysisEnum()) 
-			){
-		
-		CreatePVectorSlopeCompute( pg,inputs,analysis_type);
+	if (analysis_type==ControlAnalysisEnum()){
+		
+		CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
+	}
+	else if (analysis_type==DiagnosticAnalysisEnum()){
+	
+		if (sub_analysis_type==HorizAnalysisEnum()){
+
+			CreatePVectorDiagnosticHoriz( pg,inputs,analysis_type,sub_analysis_type);
+		}
+		else if (sub_analysis_type==VertAnalysisEnum()){
+		
+			CreatePVectorDiagnosticVert( pg,inputs,analysis_type,sub_analysis_type);
+		}
+		else if (sub_analysis_type==StokesAnalysisEnum()){
+		
+			CreatePVectorDiagnosticStokes( pg,inputs,analysis_type,sub_analysis_type);
+		}
+		else throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","sub_analysis: ",sub_analysis_type," not supported yet"));
+	}
+	else if (analysis_type==SlopeComputeAnalysisEnum()){
+		
+		CreatePVectorSlopeCompute( pg,inputs,analysis_type,sub_analysis_type);
 	}
 	else{
@@ -1091,5 +1096,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::Du"
-void  Penta::Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type){
+void  Penta::Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -1122,11 +1127,11 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::Gradj"
-void  Penta::Gradj(Vec grad_g,double* velocity,double* adjoint,void* inputs,int analysis_type,char* control_type){
+void  Penta::Gradj(Vec grad_g,double* velocity,double* adjoint,void* inputs,int analysis_type,int sub_analysis_type,char* control_type){
 
 	if (strcmp(control_type,"drag")==0){
-		GradjDrag( grad_g,velocity,adjoint,inputs,analysis_type);
+		GradjDrag( grad_g,velocity,adjoint,inputs,analysis_type,sub_analysis_type);
 	}
 	else if (strcmp(control_type,"B")==0){
-		GradjB( grad_g, velocity, adjoint, inputs,analysis_type);
+		GradjB( grad_g, velocity, adjoint, inputs,analysis_type,sub_analysis_type);
 	}
 	else throw ErrorException(__FUNCT__,exprintf("%s%s","control type not supported yet: ",control_type));
@@ -1135,5 +1140,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::GradjDrag"
-void  Penta::GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type){
+void  Penta::GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type){
 	
 	
@@ -1147,5 +1152,5 @@
 		
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-		tria->GradjDrag( grad_g,u_g,lambda_g,inputs,analysis_type);
+		tria->GradjDrag( grad_g,u_g,lambda_g,inputs,analysis_type,sub_analysis_type);
 		delete tria;
 		return;
@@ -1155,5 +1160,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::GradjB"
-void  Penta::GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type){
+void  Penta::GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
@@ -1161,5 +1166,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::Misfit"
-double Penta::Misfit(double* velocity,double* obs_velocity,void* inputs,int analysis_type){
+double Penta::Misfit(double* velocity,double* obs_velocity,void* inputs,int analysis_type,int sub_analysis_type){
 	
 	double J;
@@ -1641,5 +1646,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::CreatePVectorDiagnosticHoriz"
-void Penta::CreatePVectorDiagnosticHoriz( Vec pg, void* vinputs,int analysis_type){
+void Penta::CreatePVectorDiagnosticHoriz( Vec pg, void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int i,j;
@@ -1707,5 +1712,5 @@
 		 *and use its CreatePVector functionality to return an elementary load vector: */
 		tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-		tria->CreatePVector(pg,inputs, analysis_type);
+		tria->CreatePVector(pg,inputs, analysis_type,sub_analysis_type);
 		delete tria;
 		return;
@@ -1997,5 +2002,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta:CreatePVectorDiagnosticVert"
-void  Penta::CreatePVectorDiagnosticVert( Vec pg, void* vinputs,int analysis_type){
+void  Penta::CreatePVectorDiagnosticVert( Vec pg, void* vinputs,int analysis_type,int sub_analysis_type){
 
 	int i;
@@ -2055,5 +2060,5 @@
 	if(onbed){
 		tria=(Tria*)SpawnTria(0,1,2); //nodes 0, 1 and 2 are on the bedrock
-		tria->CreatePVectorDiagnosticBaseVert(pg,inputs, analysis_type);
+		tria->CreatePVectorDiagnosticBaseVert(pg,inputs, analysis_type,sub_analysis_type);
 		delete tria;
 	}
@@ -2176,5 +2181,5 @@
 #define __FUNCT__ "Penta::CreateKMatrixSlopeCompute"
 
-void  Penta::CreateKMatrixSlopeCompute(Mat Kgg,void* inputs,int analysis_type){
+void  Penta::CreateKMatrixSlopeCompute(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*Collapsed formulation: */
@@ -2186,5 +2191,5 @@
 	/*Spawn Tria element from the base of the Penta: */
 	tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-	tria->CreateKMatrix(Kgg,inputs, analysis_type);
+	tria->CreateKMatrix(Kgg,inputs, analysis_type,sub_analysis_type);
 	delete tria;
 	return;
@@ -2195,5 +2200,5 @@
 #define __FUNCT__ "Penta::CreatePVectorSlopeCompute"
 
-void Penta::CreatePVectorSlopeCompute( Vec pg, void* inputs, int analysis_type){
+void Penta::CreatePVectorSlopeCompute( Vec pg, void* inputs, int analysis_type,int sub_analysis_type){
 	
 	/*Collapsed formulation: */
@@ -2205,5 +2210,5 @@
 	/*Spawn Tria element from the base of the Penta: */
 	tria=(Tria*)SpawnTria(0,1,2); //grids 0, 1 and 2 make the new tria.
-	tria->CreatePVector(pg,inputs, analysis_type);
+	tria->CreatePVector(pg,inputs, analysis_type,sub_analysis_type);
 	delete tria;
 	return;
@@ -2826,5 +2831,5 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Penta::CreatePVectorDiagnosticStokes"
-void Penta::CreatePVectorDiagnosticStokes( Vec pg, void* vinputs,int analysis_type){
+void Penta::CreatePVectorDiagnosticStokes( Vec pg, void* vinputs,int analysis_type,int sub_analysis_type){
 
 
Index: issm/trunk/src/c/objects/Penta.h
===================================================================
--- issm/trunk/src/c/objects/Penta.h	(revision 464)
+++ issm/trunk/src/c/objects/Penta.h	(revision 465)
@@ -73,8 +73,8 @@
 		int   MyRank();
 		void  Configure(void* loads,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
-		void  CreateKMatrixDiagnosticHoriz( Mat Kgg, void* inputs, int analysis_type);
-		void  CreateKMatrixDiagnosticVert( Mat Kgg, void* inputs, int analysis_type);
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreateKMatrixDiagnosticHoriz( Mat Kgg, void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreateKMatrixDiagnosticVert( Mat Kgg, void* inputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
 		void  GetDofList(int* doflist,int* pnumberofdofs);
@@ -84,9 +84,9 @@
 		void  GetNodes(void** nodes);
 		int   GetOnBed();
-		void  Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type);
-		void  Gradj(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,char* control_type);
-		void  GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type);
-		void  GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type);
-        double Misfit(double* u_g,double* u_g_obs,void* inputs,int analysis_type);
+		void  Du(Vec du_g,double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type);
+		void  Gradj(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type,char* control_type);
+		void  GradjDrag(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type);
+		void  GradjB(Vec grad_g,double* u_g,double* lambda_g,void* inputs,int analysis_type,int sub_analysis_type);
+        double Misfit(double* u_g,double* u_g_obs,void* inputs,int analysis_type,int sub_analysis_type);
 		
 		void          GetThicknessList(double* thickness_list);
@@ -105,6 +105,6 @@
 		void  GetNodalFunctionsDerivativesParams(double* dl1dl2dl3dl4dl5dl6,double* gauss_l1l2l3l4);
 		void  GetJacobianInvert(double*  Jinv, double* xyz_list,double* gauss_l1l2l3l4);
-		void  CreatePVectorDiagnosticHoriz( Vec pg, void* inputs,int analysis_type);
-		void  CreatePVectorDiagnosticVert( Vec pg, void* inputs,int analysis_type);
+		void  CreatePVectorDiagnosticHoriz( Vec pg, void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticVert( Vec pg, void* inputs,int analysis_type,int sub_analysis_type);
 		void  GetParameterValue(double* pvalue, double* v_list,double* gauss_l1l2l3l4);
 		void  GetParameterDerivativeValue(double* p, double* p_list,double* xyz_list, double* gauss_l1l2l3l4);
@@ -113,9 +113,9 @@
 		void  SlopeExtrude(Vec sg,double* sg_serial);
 		void  ComputePressure(Vec p_g);
-		void  CreateKMatrixSlopeCompute(Mat Kgg,void* vinputs,int analysis_type);
-		void  CreatePVectorSlopeCompute( Vec pg, void* vinputs, int analysis_type);
+		void  CreateKMatrixSlopeCompute(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVectorSlopeCompute( Vec pg, void* vinputs, int analysis_type,int sub_analysis_type);
 
-		void  CreateKMatrixDiagnosticStokes( Mat Kgg, void* vinputs, int analysis_type);
-		void  CreatePVectorDiagnosticStokes( Vec pg, void* vinputs,int analysis_type);
+		void  CreateKMatrixDiagnosticStokes( Mat Kgg, void* vinputs, int analysis_type,int sub_analysis_type);
+		void  CreatePVectorDiagnosticStokes( Vec pg, void* vinputs,int analysis_type,int sub_analysis_type);
 		void  ReduceMatrixStokes(double* Ke_reduced, double* Ke_temp);
 		void  GetMatrixInvert(double*  Ke_invert, double* Ke);
Index: issm/trunk/src/c/objects/Sing.cpp
===================================================================
--- issm/trunk/src/c/objects/Sing.cpp	(revision 464)
+++ issm/trunk/src/c/objects/Sing.cpp	(revision 465)
@@ -193,14 +193,14 @@
 #define __FUNCT__ "Sing::CreateKMatrix"
 
-void  Sing::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type){
+void  Sing::CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type){
 
 	/*Just branch to the correct element stiffness matrix generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==DiagnosticHutterAnalysisEnum()){
-
-		CreateKMatrixDiagnosticHutter( Kgg,inputs,analysis_type);
+	if ((analysis_type==DiagnosticAnalysisEnum()) && (sub_analysis_type==HutterAnalysisEnum())){
+
+		CreateKMatrixDiagnosticHutter( Kgg,inputs,analysis_type,sub_analysis_type);
 
 	}
 	else{
-		throw ErrorException(__FUNCT__,exprintf("%s%i%s\n","analysis: ",analysis_type," not supported yet"));
+		throw ErrorException(__FUNCT__,exprintf("%s%i%s%i%s\n","analysis: ",analysis_type," and sub_analysis_type: ",sub_analysis_type," not supported yet"));
 	}
 
@@ -211,5 +211,5 @@
 #define __FUNCT__ "Sing::CreateKMatrixDiagnosticHutter"
 
-void  Sing::CreateKMatrixDiagnosticHutter(Mat Kgg,void* vinputs,int analysis_type){
+void  Sing::CreateKMatrixDiagnosticHutter(Mat Kgg,void* vinputs,int analysis_type,int sub_analysis_type){
 	
 	const int numgrids=1;
@@ -234,9 +234,11 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Sing::CreatePVector"
-void  Sing::CreatePVector(Vec pg,void* inputs,int analysis_type){
+void  Sing::CreatePVector(Vec pg,void* inputs,int analysis_type,int sub_analysis_type){
 	
 	/*Just branch to the correct load generator, according to the type of analysis we are carrying out: */
-	if (analysis_type==DiagnosticHutterAnalysisEnum()){
-		CreatePVectorDiagnosticHutter( pg,inputs,analysis_type);
+	if ((analysis_type==DiagnosticAnalysisEnum()) && (sub_analysis_type==HutterAnalysisEnum())){
+	
+			CreatePVectorDiagnosticHutter( pg,inputs,analysis_type,sub_analysis_type);
+
 	}
 	else{
@@ -251,5 +253,5 @@
 #define __FUNCT__ "Sing::CreatePVectorDiagnosticHutter"
 
-void Sing::CreatePVectorDiagnosticHutter( Vec pg, void* vinputs, int analysis_type){
+void Sing::CreatePVectorDiagnosticHutter( Vec pg, void* vinputs, int analysis_type,int sub_analysis_type){
 	
 	
@@ -427,25 +429,25 @@
 #undef __FUNCT__ 
 #define __FUNCT__ "Sing::Du"
-void  Sing::Du(_p_Vec*, double*, double*, void*, int){
+void  Sing::Du(_p_Vec*, double*, double*, void*, int,int){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Sing::Gradj"
-void  Sing::Gradj(_p_Vec*, double*, double*, void*, int, char*){
+void  Sing::Gradj(_p_Vec*, double*, double*, void*, int, int ,char*){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Sing::GradjDrag"
-void  Sing::GradjDrag(_p_Vec*, double*, double*, void*, int){
+void  Sing::GradjDrag(_p_Vec*, double*, double*, void*, int,int){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Sing::GradjB"
-void  Sing::GradjB(_p_Vec*, double*, double*, void*, int){
+void  Sing::GradjB(_p_Vec*, double*, double*, void*, int,int){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
 #undef __FUNCT__ 
 #define __FUNCT__ "Sing::Misfit"
-double Sing::Misfit(double*, double*, void*, int){
+double Sing::Misfit(double*, double*, void*, int,int){
 	throw ErrorException(__FUNCT__," not supported yet!");
 }
Index: issm/trunk/src/c/objects/Sing.h
===================================================================
--- issm/trunk/src/c/objects/Sing.h	(revision 464)
+++ issm/trunk/src/c/objects/Sing.h	(revision 465)
@@ -51,12 +51,12 @@
 		int   MyRank();
 		void  Configure(void* loads,void* nodes,void* materials);
-		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type);
-		void  CreatePVector(Vec pg, void* inputs, int analysis_type);
+		void  CreateKMatrix(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
+		void  CreatePVector(Vec pg, void* inputs, int analysis_type,int sub_analysis_type);
 		void  UpdateFromInputs(void* inputs);
 		void  GetDofList(int* doflist,int* pnumberofdofs);
 		void  GetDofList1(int* doflist);
-		void  CreateKMatrixDiagnosticHutter(Mat Kgg,void* inputs,int analysis_type);
+		void  CreateKMatrixDiagnosticHutter(Mat Kgg,void* inputs,int analysis_type,int sub_analysis_type);
 		void  GetParameterValue(double* pp, double* plist, double* gauss_l1l2l3);
-		void  CreatePVectorDiagnosticHutter(Vec pg,void* inputs,int analysis_type);
+		void  CreatePVectorDiagnosticHutter(Vec pg,void* inputs,int analysis_type,int sub_analysis_type);
 		void* GetMatPar();
 
@@ -73,9 +73,9 @@
 		void  GetBedList(double*);
 		void  GetThicknessList(double* thickness_list);
-		void  Du(_p_Vec*, double*, double*, void*, int);
-		void  Gradj(_p_Vec*, double*, double*, void*, int, char*);
-		void  GradjDrag(_p_Vec*, double*, double*, void*, int);
-		void  GradjB(_p_Vec*, double*, double*, void*, int);
-		double Misfit(double*, double*, void*, int);
+		void  Du(_p_Vec*, double*, double*, void*, int,int);
+		void  Gradj(_p_Vec*, double*, double*, void*, int, int,char*);
+		void  GradjDrag(_p_Vec*, double*, double*, void*, int,int);
+		void  GradjB(_p_Vec*, double*, double*, void*, int,int);
+		double Misfit(double*, double*, void*, int,int);
 
 
